--- flickrapi.txt	2006-08-15 23:56:39.000000000 +0300
+++ flickrapi.py	2006-09-30 12:09:14.000000000 +0300
@@ -17,6 +17,7 @@
 # Release 6: fix upload sig bug (thanks Deepak Jois), encode test output
 # Release 7: fix path construction, Manish Rai Jain's improvements, exceptions
 # Release 8: change API endpoint to "api.flickr.com"
+# Release 8.hsivonen: Fix UTF-8 issues and print auth url
 #
 # Work by (or inspired by) Manish Rai Jain <manishrjain@gmail.com>:
 #
@@ -44,6 +45,8 @@
 # beej@beej.us
 #
 
+# Modified by Henri Sivonen, hsivonen@iki.fi
+
 import sys
 import md5
 import string
@@ -191,7 +194,7 @@
 		dataName = self.secret
 		keys = data.keys()
 		keys.sort()
-		for a in keys: dataName += (a + data[a])
+		for a in keys: dataName += (a + data[a].encode("utf-8"))
 		#print dataName
 		hash = md5.new()
 		hash.update(dataName)
@@ -225,8 +228,11 @@
 				url = "http://" + FlickrAPI.flickrHost + \
 					FlickrAPI.flickrRESTForm
 				arg["method"] = _method
-				postData = urllib.urlencode(arg) + "&api_sig=" + \
-					_self.__sign(arg)
+				argEncoded = {}
+				for k in arg.keys():
+				  argEncoded[k] = arg[k].encode("utf-8")
+				postData = urllib.urlencode(argEncoded) + "&api_sig=" + \
+					_self.__sign(argEncoded)
 				#print "--url---------------------------------------------"
 				#print url
 				#print "--postData----------------------------------------"
@@ -474,7 +480,9 @@
 			frob = rsp.frob[0].elementText
 
 			# validate online
-			os.system("%s '%s'" % (browser, self.__getAuthURL(perms, frob)))
+			#os.system("%s '%s'" % (browser, self.__getAuthURL(perms, frob)))
+			print self.__getAuthURL(perms, frob)
+			raw_input()
 
 			# get a token
 			rsp = self.auth_getToken(api_key=self.apiKey, frob=frob)
